/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of ZooKeeper.xs. Do not edit this file, edit ZooKeeper.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "ZooKeeper.xs"
/* Net::ZooKeeper - Perl extension for Apache ZooKeeper
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <pthread.h>                    /* pthread_mutex_lock(), etc. */
#include <string.h>                     /* memset(), etc. */
#include <limits.h>                     /* CHAR_BIT */
#include <sys/time.h>                   /* gettimeofday() */

#include <zookeeper/zookeeper.h>

#include "build/check_zk_version.h"


#define PACKAGE_NAME "Net::ZooKeeper"
#define PACKAGE_SIGNATURE 19631123

#define STAT_PACKAGE_NAME "Net::ZooKeeper::Stat"
#define STAT_PACKAGE_SIGNATURE 19960512

#define WATCH_PACKAGE_NAME "Net::ZooKeeper::Watch"
#define WATCH_PACKAGE_SIGNATURE 20050326

#define MAX_KEY_NAME_LEN 16             /* "children_version" */

#define NUM_ACL_ENTRY_KEYS 3
#define NUM_KEYS 8
#define NUM_STAT_KEYS 11
#define NUM_WATCH_KEYS 3

#define DEFAULT_RECV_TIMEOUT_MSEC 10000

#define DEFAULT_DATA_BUF_LEN 1023
#define DEFAULT_PATH_BUF_LEN 1023
#define DEFAULT_WATCH_TIMEOUT 60000

#define ZOO_LOG_LEVEL_OFF 0

#ifndef strcaseEQ
#define strcaseEQ(a,b) (!strcasecmp((a),(b)))
#endif


typedef struct Stat zk_stat_t;

typedef HV* Net__ZooKeeper__Stat;

typedef struct zk_watch_t zk_watch_t;

struct zk_watch_t {
    pthread_mutex_t mutex;
    pthread_cond_t cond;
    int done;
    int watch_event_triggered;
    int ret;
    int event_type;
    int event_state;
    unsigned int timeout;
    zk_watch_t *prev;
    zk_watch_t *next;
    int ref_count;
};

typedef HV* Net__ZooKeeper__Watch;

typedef struct {
    zhandle_t *handle;
    zk_watch_t *first_watch;
    int data_buf_len;
    int path_buf_len;
    unsigned int watch_timeout;
    const char *hosts;
    int hosts_len;
    int last_ret;
    int last_errno;
} zk_t;

typedef HV* Net__ZooKeeper;

typedef struct {
    I32 signature;
    union {
        zk_t *zk;
        zk_stat_t *stat;
        zk_watch_t *watch;
    } handle;
} zk_handle_t;

typedef struct {
    const char name[MAX_KEY_NAME_LEN + 1];
    U32 name_len;
    size_t offset;
    size_t size;
    U32 hash;
} zk_key_t;


static zk_key_t zk_acl_entry_keys[NUM_ACL_ENTRY_KEYS] = {
    {"perms", 0, 0, 0, 0},
    {"scheme", 0, 0, 0, 0},
    {"id", 0, 0, 0, 0}
};

static zk_key_t zk_keys[NUM_KEYS] = {
    {"data_read_len", 0, 0, 0, 0},
    {"path_read_len", 0, 0, 0, 0},
    {"watch_timeout", 0, 0, 0, 0},
    {"hosts", 0, 0, 0, 0},
    {"session_timeout", 0, 0, 0, 0},
    {"session_id", 0, 0, 0, 0},
    {"pending_watches", 0, 0, 0, 0},
    {"state", 0, 0, 0, 0}
};

static zk_key_t zk_stat_keys[NUM_STAT_KEYS] = {
    {"czxid", 0, offsetof(struct Stat, czxid),
     sizeof(((struct Stat*) 0)->czxid), 0},
    {"mzxid", 0, offsetof(struct Stat, mzxid),
     sizeof(((struct Stat*) 0)->mzxid), 0},
    {"ctime", 0, offsetof(struct Stat, ctime),
     sizeof(((struct Stat*) 0)->ctime), 0},
    {"mtime", 0, offsetof(struct Stat, mtime),
     sizeof(((struct Stat*) 0)->mtime), 0},
    {"version", 0, offsetof(struct Stat, version),
     sizeof(((struct Stat*) 0)->version), 0},
    {"children_version", 0, offsetof(struct Stat, cversion),
     sizeof(((struct Stat*) 0)->cversion), 0},
    {"acl_version", 0, offsetof(struct Stat, aversion),
     sizeof(((struct Stat*) 0)->aversion), 0},
    {"ephemeral_owner", 0, offsetof(struct Stat, ephemeralOwner),
     sizeof(((struct Stat*) 0)->ephemeralOwner), 0},
    {"data_len", 0, offsetof(struct Stat, dataLength),
     sizeof(((struct Stat*) 0)->dataLength), 0},
    {"num_children", 0, offsetof(struct Stat, numChildren),
     sizeof(((struct Stat*) 0)->numChildren), 0},
    {"children_zxid", 0, offsetof(struct Stat, pzxid),
     sizeof(((struct Stat*) 0)->pzxid), 0}
};

static zk_key_t zk_watch_keys[NUM_WATCH_KEYS] = {
    {"timeout", 0, 0, 0, 0},
    {"event", 0, 0, 0, 0},
    {"state", 0, 0, 0, 0}
};

static int zk_ignore_session_events = 0;

static void _zk_watcher(zhandle_t *handle, int type, int state,
                        const char *path, void *context)
{
    zk_watch_t *watch_ctx = context;

    bool is_session_event = type == ZOO_SESSION_EVENT;
    if (is_session_event && zk_ignore_session_events) {
        return;
    }
    if (!is_session_event) {
        // mark this watch for garbage collection
        watch_ctx->watch_event_triggered = 1;
    }

    pthread_mutex_lock(&watch_ctx->mutex);

    watch_ctx->event_type = type;
    watch_ctx->event_state = state;

    watch_ctx->done = 1;

    pthread_cond_signal(&watch_ctx->cond);
    pthread_mutex_unlock(&watch_ctx->mutex);

    return;
}

static void _zk_auth_completion(int ret, const void *data)
{
    zk_watch_t *watch_ctx = (zk_watch_t*) data;

    pthread_mutex_lock(&watch_ctx->mutex);

    watch_ctx->ret = ret;

    watch_ctx->done = 1;

    pthread_cond_signal(&watch_ctx->cond);
    pthread_mutex_unlock(&watch_ctx->mutex);

    return;
}

static zk_watch_t *_zk_create_watch(pTHX)
{
    zk_watch_t *watch;

    Newxz(watch, 1, zk_watch_t);

    if (pthread_mutex_init(&watch->mutex, NULL)) {
        int save_errno = errno;

        Safefree(watch);

        errno = save_errno;
        return NULL;
    }

    if (pthread_cond_init(&watch->cond, NULL)) {
        int save_errno = errno;

        pthread_mutex_destroy(&watch->mutex);
        Safefree(watch);

        errno = save_errno;
        return NULL;
    }

    return watch;
}

static void _zk_destroy_watch(pTHX_ zk_watch_t *watch)
{
    pthread_cond_destroy(&watch->cond);
    pthread_mutex_destroy(&watch->mutex);

    Safefree(watch);

    return;
}

static zk_watch_t *_zk_acquire_watch(pTHX)
{
    zk_watch_t *watch = _zk_create_watch(aTHX);

    if (watch) {
        watch->ref_count = 1;
    }

    return watch;
}

static void _zk_release_watch(pTHX_ zk_watch_t *watch, int list)
{
    if (list) {
        if (watch->prev) {
            watch->prev->next = watch->next;
        }
        if (watch->next) {
            watch->next->prev = watch->prev;
        }
        watch->prev = NULL;
        watch->next = NULL;
    }

    if (--watch->ref_count == 0) {
        _zk_destroy_watch(aTHX_ watch);
    }

    return;
}

static unsigned int _zk_release_watches(pTHX_ zk_watch_t *first_watch,
                                        int final)
{
    zk_watch_t *watch = first_watch->next;
    unsigned int pending_watches = 0;

    while (watch) {
        zk_watch_t *next_watch = watch->next;
        int done = final;

        if (!final) {
            pthread_mutex_lock(&watch->mutex);
            // only release watches if the watch event has been triggered
            //   otherwise zookeeper may trigger it again
            done = watch->watch_event_triggered;
            pthread_mutex_unlock(&watch->mutex);
        }

        if (done) {
            _zk_release_watch(aTHX_ watch, 1);
        }
        else {
            ++pending_watches;
        }

        watch = next_watch;
    }

    return pending_watches;
}

static void _zk_replace_watch(pTHX_ zk_handle_t *handle,
                              zk_watch_t *first_watch,
                              zk_watch_t *old_watch, zk_watch_t *new_watch)
{
    zk_watch_t *next_watch;

    new_watch->timeout = old_watch->timeout;

    _zk_release_watch(aTHX_ old_watch, 0);

    /* cleanup any completed watches not tied to a handle */
    _zk_release_watches(aTHX_ first_watch, 0);

    next_watch = first_watch->next;

    new_watch->prev = first_watch;
    new_watch->next = next_watch;

    if (next_watch) {
        next_watch->prev = new_watch;
    }

    first_watch->next = new_watch;

    ++new_watch->ref_count;

    handle->handle.watch = new_watch;

    return;
}

static void _zk_free_acl(pTHX_ struct ACL_vector *acl)
{
    if (acl->data) {
        Safefree(acl->data);
    }

    return;
}

static const char *_zk_fill_acl(pTHX_ AV *acl_arr, struct ACL_vector *acl)
{
    I32 num_acl_entries = av_len(acl_arr) + 1;
    int i;

    Zero(acl, 1, struct ACL_vector);

    if (num_acl_entries <= 0) {
        return NULL;
    }
    else if (num_acl_entries > PERL_INT_MAX) {
        num_acl_entries = PERL_INT_MAX;
    }

    Newx(acl->data, num_acl_entries, struct ACL);

    for (i = 0; i < num_acl_entries; ++i) {
        SV **acl_entry_ptr;
        HV *acl_entry_hash;
        zk_key_t *key;
        SV **val_ptr;
        struct ACL acl_entry;

        acl_entry_ptr = av_fetch(acl_arr, i, 0);

        if (!acl_entry_ptr) {
            continue;
        }

        if (!SvROK(*acl_entry_ptr) ||
            SvTYPE(SvRV(*acl_entry_ptr)) != SVt_PVHV) {
            _zk_free_acl(aTHX_ acl);

            return "invalid ACL entry hash reference";
        }

        acl_entry_hash = (HV*) SvRV(*acl_entry_ptr);

        key = &zk_acl_entry_keys[0];
        val_ptr = hv_fetch(acl_entry_hash, key->name, key->name_len, 0);

        if (!val_ptr) {
            _zk_free_acl(aTHX_ acl);

            return "no ACL entry perms element";
        }

        acl_entry.perms = SvIV(*val_ptr);

        if (!acl_entry.perms || (acl_entry.perms & ~ZOO_PERM_ALL)) {
            _zk_free_acl(aTHX_ acl);

            return "invalid ACL entry perms";
        }

        key = &zk_acl_entry_keys[1];
        val_ptr = hv_fetch(acl_entry_hash, key->name, key->name_len, 0);

        if (!val_ptr) {
            _zk_free_acl(aTHX_ acl);

            return "no ACL entry scheme element";
        }

        acl_entry.id.scheme = SvPV_nolen(*val_ptr);

        key = &zk_acl_entry_keys[2];
        val_ptr = hv_fetch(acl_entry_hash, key->name, key->name_len, 0);

        if (!val_ptr) {
            _zk_free_acl(aTHX_ acl);

            return "no ACL entry id element";
        }

        acl_entry.id.id = SvPV_nolen(*val_ptr);

        ++acl->count;
        acl->data[i] = acl_entry;
    }

    return NULL;
}

static void _zk_fill_acl_entry_hash(pTHX_ struct ACL *acl_entry,
                                    HV *acl_entry_hash)
{
    zk_key_t *key;
    SV *val;

    key = &zk_acl_entry_keys[0];
    val = newSViv(acl_entry->perms);

    if (!hv_store(acl_entry_hash, key->name, key->name_len, val, key->hash)) {
        SvREFCNT_dec(val);
    }

    key = &zk_acl_entry_keys[1];
    val = newSVpv(acl_entry->id.scheme, 0);

    if (!hv_store(acl_entry_hash, key->name, key->name_len, val, key->hash)) {
        SvREFCNT_dec(val);
    }

    key = &zk_acl_entry_keys[2];
    val = newSVpv(acl_entry->id.id, 0);

    if (!hv_store(acl_entry_hash, key->name, key->name_len, val, key->hash)) {
        SvREFCNT_dec(val);
    }

    return;
}

static zk_handle_t *_zk_check_handle_inner(pTHX_ HV *attr_hash,
                                           I32 package_signature)
{
    zk_handle_t *handle = NULL;

    if (SvRMAGICAL(attr_hash)) {
        MAGIC *magic = mg_find((SV*) attr_hash, PERL_MAGIC_ext);

        if (magic) {
            handle = (zk_handle_t*) magic->mg_ptr;

            if (handle->signature != package_signature) {
                handle = NULL;
            }
        }
    }

    return handle;
}

static zk_handle_t *_zk_check_handle_outer(pTHX_ HV *hash, HV **attr_hash_ptr,
                                           const char *package_name,
                                           I32 package_signature)
{
    zk_handle_t *handle = NULL;

    if (attr_hash_ptr) {
        *attr_hash_ptr = NULL;
    }

    if (SvRMAGICAL((SV*) hash)) {
        MAGIC *magic = mg_find((SV*) hash, PERL_MAGIC_tied);

        if (magic) {
            SV *attr = magic->mg_obj;

            if (SvROK(attr) && SvTYPE(SvRV(attr)) == SVt_PVHV &&
                sv_derived_from(attr, package_name)) {
                HV *attr_hash = (HV*) SvRV(attr);

                handle = _zk_check_handle_inner(aTHX_ attr_hash,
                                                package_signature);

                if (handle && attr_hash_ptr) {
                    *attr_hash_ptr = attr_hash;
                }
            }
        }
    }

    return handle;
}

static zk_t *_zk_get_handle_inner(pTHX_ Net__ZooKeeper attr_hash)
{
    zk_handle_t *handle;

    handle = _zk_check_handle_inner(aTHX_ attr_hash, PACKAGE_SIGNATURE);

    return handle ? handle->handle.zk : NULL;
}

static zk_t *_zk_get_handle_outer(pTHX_ Net__ZooKeeper zkh)
{
    zk_handle_t *handle;

    handle = _zk_check_handle_outer(aTHX_ zkh, NULL, PACKAGE_NAME,
                                    PACKAGE_SIGNATURE);

    return handle ? handle->handle.zk : NULL;
}

static zk_stat_t *_zks_get_handle_inner(pTHX_ Net__ZooKeeper__Stat attr_hash)
{
    zk_handle_t *handle;

    handle = _zk_check_handle_inner(aTHX_ attr_hash, STAT_PACKAGE_SIGNATURE);

    return handle ? handle->handle.stat : NULL;
}

static zk_stat_t *_zks_get_handle_outer(pTHX_ Net__ZooKeeper__Stat zksh)
{
    zk_handle_t *handle;

    handle = _zk_check_handle_outer(aTHX_ zksh, NULL, STAT_PACKAGE_NAME,
                                    STAT_PACKAGE_SIGNATURE);

    return handle ? handle->handle.stat : NULL;
}

static zk_watch_t *_zkw_get_handle_inner(pTHX_ Net__ZooKeeper__Watch attr_hash)
{
    zk_handle_t *handle;

    handle = _zk_check_handle_inner(aTHX_ attr_hash, WATCH_PACKAGE_SIGNATURE);

    return handle ? handle->handle.watch : NULL;
}

static zk_watch_t *_zkw_get_handle_outer(pTHX_ Net__ZooKeeper__Watch zkwh,
                                         zk_handle_t **handle_ptr)
{
    zk_handle_t *handle;

    handle = _zk_check_handle_outer(aTHX_ zkwh, NULL, WATCH_PACKAGE_NAME,
                                    WATCH_PACKAGE_SIGNATURE);

    if (handle_ptr) {
        *handle_ptr = handle;
    }

    return handle ? handle->handle.watch : NULL;
}


#line 592 "ZooKeeper.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 736 "ZooKeeper.c"

XS_EUPXS(XS_Net__ZooKeeper_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_constant)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "alias=Nullch");
    {
	char *	alias;
	I32	RETVAL;
	dXSTARG;

	if (items < 1)
	    alias = Nullch;
	else {
	    alias = (char *)SvPV_nolen(ST(0))
;
	}
#line 674 "ZooKeeper.xs"
         if (!ix) {
             if (!alias) {
                 alias = GvNAME(CvGV(cv));
             }

             if (strEQ(alias, "ZOK")) {
                 RETVAL = ZOK;
             }
             else if (strEQ(alias, "ZOO_LOG_LEVEL_OFF")) {
                 RETVAL = ZOO_LOG_LEVEL_OFF;
             }
             else {
                 Perl_croak(aTHX_ "unknown " PACKAGE_NAME " constant: %s",
                            alias);
             }
         }
         else {
             RETVAL = ix;
         }
#line 776 "ZooKeeper.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__ZooKeeper_acl_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_acl_constant)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "alias=Nullch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	alias;
#line 705 "ZooKeeper.xs"
        struct ACL_vector acl;
        AV *acl_arr;
        int i;
#line 798 "ZooKeeper.c"
	AV *	RETVAL;

	if (items < 1)
	    alias = Nullch;
	else {
	    alias = (char *)SvPV_nolen(ST(0))
;
	}
#line 709 "ZooKeeper.xs"
        if (!ix && !alias) {
            alias = GvNAME(CvGV(cv));
        }

        if (ix == 1 || (alias != NULL && strEQ(alias, "ZOO_OPEN_ACL_UNSAFE"))) {
            acl = ZOO_OPEN_ACL_UNSAFE;
        }
        else if (ix == 2 || (alias != NULL && strEQ(alias, "ZOO_READ_ACL_UNSAFE"))) {
            acl = ZOO_READ_ACL_UNSAFE;
        }
        else if (ix == 3 || (alias != NULL && strEQ(alias, "ZOO_CREATOR_ALL_ACL"))) {
            acl = ZOO_CREATOR_ALL_ACL;
        }
        else {
             Perl_croak(aTHX_ "unknown " PACKAGE_NAME " constant: %s", alias);
        }

        acl_arr = newAV();

        av_extend(acl_arr, acl.count);

        for (i = 0; i < acl.count; ++i) {
            HV *acl_entry_hash = newHV();
            SV *val;

            _zk_fill_acl_entry_hash(aTHX_ &acl.data[i], acl_entry_hash);

            val = newRV_noinc((SV*) acl_entry_hash);

            if (!av_store(acl_arr, i, val)) {
                SvREFCNT_dec(val);
            }
        }

        ST(0) = sv_2mortal(newRV_noinc((SV*) acl_arr));

        XSRETURN(1);
#line 845 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_set_log_level); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_set_log_level)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "level");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	level = (int)SvIV(ST(0))
;
#line 752 "ZooKeeper.xs"
        if (level < ZOO_LOG_LEVEL_OFF || level > ZOO_LOG_LEVEL_DEBUG) {
            Perl_croak(aTHX_ "invalid log level: %d", level);
        }

        zoo_set_debug_level(level);

        XSRETURN_EMPTY;
#line 871 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_set_deterministic_conn_order); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_set_deterministic_conn_order)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flag");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	bool	flag = (bool)SvTRUE(ST(0))
;
#line 765 "ZooKeeper.xs"
        zoo_deterministic_conn_order(!!flag);

        XSRETURN_EMPTY;
#line 893 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_set_ignore_session_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_set_ignore_session_events)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flag");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	bool	flag = (bool)SvTRUE(ST(0))
;
#line 773 "ZooKeeper.xs"
        zk_ignore_session_events = flag;

        XSRETURN_EMPTY;
#line 915 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "package, hosts, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	char *	hosts = (char *)SvPV_nolen(ST(1))
;
#line 782 "ZooKeeper.xs"
        int recv_timeout = DEFAULT_RECV_TIMEOUT_MSEC;
        const clientid_t *client_id = NULL;
        zk_t *zk;
        zk_handle_t *handle;
        HV *stash, *zk_hash, *attr_hash;
        SV *attr;
        int i;
#line 943 "ZooKeeper.c"
#line 790 "ZooKeeper.xs"
        if (items > 2 && items % 2) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        for (i = 2; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "session_timeout")) {
                recv_timeout = SvIV(ST(i + 1));

                /* NOTE: would be nice if requirement in zookeeper_interest()
                 * that recv_timeout*2 be non-negative was documented
                 */
                if (recv_timeout < 0 || recv_timeout > (PERL_INT_MAX >> 1)) {
                    Perl_croak(aTHX_ "invalid session timeout: %d",
                               recv_timeout);
                }
            }
            else if (strcaseEQ(key, "session_id")) {
                STRLEN client_id_len;

                client_id = (const clientid_t*) SvPV(ST(i + 1), client_id_len);

                if (client_id_len != sizeof(clientid_t)) {
                    Perl_croak(aTHX_ "invalid session ID");
                }
            }
        }

        Newxz(zk, 1, zk_t);

        zk->handle = zookeeper_init(hosts, NULL, recv_timeout,
                                    client_id, NULL, 0);

        if (!zk->handle) {
            Safefree(zk);

            XSRETURN_UNDEF;
        }

        Newxz(zk->first_watch, 1, zk_watch_t);

        zk->data_buf_len = DEFAULT_DATA_BUF_LEN;
        zk->path_buf_len = DEFAULT_PATH_BUF_LEN;
        zk->watch_timeout = DEFAULT_WATCH_TIMEOUT;

        zk->hosts_len = strlen(hosts);
        zk->hosts = savepvn(hosts, zk->hosts_len);

        Newx(handle, 1, zk_handle_t);

        handle->signature = PACKAGE_SIGNATURE;
        handle->handle.zk = zk;

        /* We use several tricks from DBI here.  The attr_hash is our
         * empty inner hash; we attach extra magic to it in the form of
         * our zk_handle_t structure.  Then we tie attr_hash to zk_hash,
         * our outer hash.  This is what is passed around (by reference) by
         * callers.
         *
         * Most methods use _zk_get_handle_outer() which finds our inner
         * handle, then returns the zk_t structure from its extra magic
         * pointer.
         *
         * However, the tied hash methods, FETCH(), STORE(), and so forth,
         * receive an already-dereferenced inner handle hash.  This is
         * because we bless both inner and outer handles into this class,
         * so when a caller's code references a hash element in our
         * outer handle, Perl detects its tied magic, looks up the
         * tied object (our inner handle) and invokes the tied hash methods
         * in its class on it.  Since we blessed it into the same class
         * as the outer handle, these methods simply reside in our package.
         */

        stash = gv_stashpv(package, GV_ADDWARN);

        attr_hash = newHV();

        sv_magic((SV*) attr_hash, Nullsv, PERL_MAGIC_ext,
                 (const char*) handle, 0);

        attr = sv_bless(newRV_noinc((SV*) attr_hash), stash);

        zk_hash = newHV();

        sv_magic((SV*) zk_hash, attr, PERL_MAGIC_tied, Nullch, 0);
        SvREFCNT_dec(attr);

        ST(0) = sv_bless(sv_2mortal(newRV_noinc((SV*) zk_hash)), stash);

        XSRETURN(1);
#line 1036 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "zkh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
#line 887 "ZooKeeper.xs"
        zk_handle_t *handle;
        HV *attr_hash;
        int ret = ZBADARGUMENTS;
#line 1057 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 891 "ZooKeeper.xs"
        handle = _zk_check_handle_outer(aTHX_ zkh, &attr_hash,
                                        PACKAGE_NAME, PACKAGE_SIGNATURE);

        if (!handle) {
            handle = _zk_check_handle_inner(aTHX_ zkh, PACKAGE_SIGNATURE);

            if (handle) {
                attr_hash = zkh;
                zkh = NULL;
            }
        }

        if (handle) {
            zk_t *zk = handle->handle.zk;

            ret = zookeeper_close(zk->handle);

            /* detach all now-inactive watches still tied to handles */
            _zk_release_watches(aTHX_ zk->first_watch, 1);

            Safefree(zk->first_watch);
            Safefree(zk->hosts);
            Safefree(zk);
            Safefree(handle);

            sv_unmagic((SV*) attr_hash, PERL_MAGIC_ext);
        }

        if (zkh && attr_hash) {
            sv_unmagic((SV*) zkh, PERL_MAGIC_tied);
        }

        if (GIMME_V == G_VOID) {
            XSRETURN_EMPTY;
        }
        else if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 1110 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_CLONE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 938 "ZooKeeper.xs"
        XSRETURN_EMPTY;
#line 1130 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_CLONE_SKIP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 945 "ZooKeeper.xs"
        XSRETURN_YES;
#line 1150 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_TIEHASH)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "package, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 952 "ZooKeeper.xs"
        Perl_croak(aTHX_ "tying hashes of class "
                         PACKAGE_NAME " not supported");
#line 1171 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_UNTIE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_UNTIE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, ref_count");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
	IV	ref_count = (IV)SvIV(ST(1))
;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 961 "ZooKeeper.xs"
        Perl_croak(aTHX_ "untying hashes of class "
                         PACKAGE_NAME " not supported");
#line 1203 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
#line 969 "ZooKeeper.xs"
        zk_t *zk;
#line 1222 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 971 "ZooKeeper.xs"
        zk = _zk_get_handle_inner(aTHX_ attr_hash);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        ST(0) = sv_2mortal(newSVpvn(zk_keys[0].name, zk_keys[0].name_len));

        XSRETURN(1);
#line 1243 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
	SV *	attr_key = ST(1)
;
#line 987 "ZooKeeper.xs"
        zk_t *zk;
        char *key;
        int i;
#line 1266 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 991 "ZooKeeper.xs"
        zk = _zk_get_handle_inner(aTHX_ attr_hash);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_KEYS; ++i) {
            if (strcaseEQ(key, zk_keys[i].name)) {
                ++i;

                break;
            }
        }

        if (i < NUM_KEYS) {
            ST(0) = sv_2mortal(newSVpvn(zk_keys[i].name, zk_keys[i].name_len));

            XSRETURN(1);
        }
        else {
            XSRETURN_EMPTY;
        }
#line 1302 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_SCALAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_SCALAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1021 "ZooKeeper.xs"
        XSRETURN_YES;
#line 1331 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
	SV *	attr_key = ST(1)
;
#line 1029 "ZooKeeper.xs"
        zk_t *zk;
        char *key;
        SV *val = NULL;
#line 1354 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1033 "ZooKeeper.xs"
        zk = _zk_get_handle_inner(aTHX_ attr_hash);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        if (strcaseEQ(key, "data_read_len")) {
            val = newSViv(zk->data_buf_len);
        }
        else if (strcaseEQ(key, "path_read_len")) {
            val = newSViv(zk->path_buf_len);
        }
        else if (strcaseEQ(key, "watch_timeout")) {
            val = newSVuv(zk->watch_timeout);
        }
        else if (strcaseEQ(key, "hosts")) {
            val = newSVpvn(zk->hosts, zk->hosts_len);
        }
        else if (strcaseEQ(key, "session_timeout")) {
            val = newSViv(zoo_recv_timeout(zk->handle));
        }
        else if (strcaseEQ(key, "session_id")) {
            const clientid_t *client_id;
            clientid_t null_client_id;

            client_id = zoo_client_id(zk->handle);

            memset(&null_client_id, 0, sizeof(clientid_t));

            if (!memcmp(client_id, &null_client_id, sizeof(clientid_t))) {
                val = newSVpv("", 0);
            }
            else {
                val = newSVpvn((const char*) client_id, sizeof(clientid_t));
            }
        }
        else if (strcaseEQ(key, "pending_watches")) {
            /* cleanup any completed watches not tied to a handle */
            val = newSVuv(_zk_release_watches(aTHX_ zk->first_watch, 0));
        }
        else if (strcaseEQ(key, "state")) {
            val = newSViv(zoo_state(zk->handle));
        }

        if (val) {
            ST(0) = sv_2mortal(val);

            XSRETURN(1);
        }

        Perl_warn(aTHX_ "invalid element: %s", key);

        XSRETURN_UNDEF;
#line 1421 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "attr_hash, attr_key, attr_val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
	SV *	attr_key = ST(1)
;
	SV *	attr_val = ST(2)
;
#line 1096 "ZooKeeper.xs"
        zk_t *zk;
        char *key;
#line 1445 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1099 "ZooKeeper.xs"
        zk = _zk_get_handle_inner(aTHX_ attr_hash);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        if (strcaseEQ(key, "data_read_len")) {
            int val = SvIV(attr_val);

            if (val < 0) {
                Perl_croak(aTHX_ "invalid data read length: %d", val);
            }

            zk->data_buf_len = val;
        }
        else if (strcaseEQ(key, "path_read_len")) {
            int val = SvIV(attr_val);

            if (val < 0) {
                Perl_croak(aTHX_ "invalid path read length: %d", val);
            }

            zk->path_buf_len = val;
        }
        else if (strcaseEQ(key, "watch_timeout")) {
            zk->watch_timeout = SvUV(attr_val);
        }
        else {
            int i;

            for (i = 0; i < NUM_KEYS; ++i) {
                if (strcaseEQ(key, zk_keys[i].name)) {
                    Perl_warn(aTHX_ "read-only element: %s", key);

                    XSRETURN_EMPTY;
                }
            }

            Perl_warn(aTHX_ "invalid element: %s", key);
        }

        XSRETURN_EMPTY;
#line 1501 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
	SV *	attr_key = ST(1)
;
#line 1150 "ZooKeeper.xs"
        zk_t *zk;
        char *key;
        int i;
#line 1524 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1154 "ZooKeeper.xs"
        zk = _zk_get_handle_inner(aTHX_ attr_hash);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_KEYS; ++i) {
            if (strcaseEQ(key, zk_keys[i].name)) {
                XSRETURN_YES;
            }
        }

        XSRETURN_NO;
#line 1551 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_DELETE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;
	SV *	attr_key = ST(1)
;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1176 "ZooKeeper.xs"
        Perl_warn(aTHX_ "deleting elements from hashes of class "
                        PACKAGE_NAME " not supported");

        XSRETURN_EMPTY;
#line 1585 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	attr_hash;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1186 "ZooKeeper.xs"
        Perl_warn(aTHX_ "clearing hashes of class "
                        PACKAGE_NAME " not supported");

        XSRETURN_EMPTY;
#line 1617 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_get_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_get_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "zkh");
    {
	Net__ZooKeeper	zkh;
#line 1196 "ZooKeeper.xs"
        zk_t *zk;
#line 1634 "ZooKeeper.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1198 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        RETVAL = newSViv(zk->last_ret);
        errno = zk->last_errno;
#line 1655 "ZooKeeper.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__ZooKeeper_add_auth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_add_auth)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "zkh, scheme, cert");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	scheme = (char *)SvPV_nolen(ST(1))
;
	char *	cert;
#line 1216 "ZooKeeper.xs"
        zk_t *zk;
        STRLEN cert_len;
        zk_watch_t *watch;
        int ret;
#line 1681 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;

	 cert = (char *) SvPV(ST(2), cert_len);
#line 1221 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (cert_len > PERL_INT_MAX) {
            Perl_croak(aTHX_ "invalid certificate length: %u", cert_len);
        }

        watch = _zk_create_watch(aTHX);

        if (!watch) {
            /* errno will be set */
            zk->last_ret = ZSYSTEMERROR;
            zk->last_errno = errno;

            XSRETURN_NO;
        }

        errno = 0;
        ret = zoo_add_auth(zk->handle, scheme, cert, cert_len,
                           _zk_auth_completion, watch);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (ret == ZOK) {
            pthread_mutex_lock(&watch->mutex);

            while (!watch->done) {
                pthread_cond_wait(&watch->cond, &watch->mutex);
            }

            pthread_mutex_unlock(&watch->mutex);

            if (watch->done) {
                ret = watch->ret;
            }
            else {
                ret = ZINVALIDSTATE;
            }

            /* errno may be set while we waited */
            zk->last_ret = ret;
            zk->last_errno = errno;
        }

        _zk_destroy_watch(aTHX_ watch);

        if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 1754 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_create)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "zkh, path, buf, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	buf;
#line 1288 "ZooKeeper.xs"
        zk_t *zk;
        STRLEN buf_len;
        int flags = 0;
        char *path_buf;
        int path_buf_len;
        AV *acl_arr = NULL;
        struct ACL_vector acl;
        int i, ret;
#line 1783 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;

	 buf = (char *) SvPV(ST(2), buf_len);
#line 1297 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 3 && !(items % 2)) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        if (buf_len > PERL_INT_MAX) {
            Perl_croak(aTHX_ "invalid data length: %u", buf_len);
        }

        path_buf_len = zk->path_buf_len;

        for (i = 3; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "path_read_len")) {
                path_buf_len = SvIV(ST(i + 1));

                if (path_buf_len < 2) {
                    Perl_croak(aTHX_ "invalid path read length: %d",
                               path_buf_len);
                }
            }
            else if (strcaseEQ(key, "flags")) {
                flags = SvIV(ST(i + 1));

                if (flags & ~(ZOO_SEQUENCE | ZOO_EPHEMERAL)) {
                    Perl_croak(aTHX_ "invalid create flags: %d", flags);
                }
            }
            else if (strcaseEQ(key, "acl")) {
                const char *err;

                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVAV) {
                    Perl_croak(aTHX_ "invalid ACL array reference");
                }

                acl_arr = (AV*) SvRV(ST(i + 1));

                err = _zk_fill_acl(aTHX_ acl_arr, &acl);

                if (err) {
                    Perl_croak(aTHX_ err);
                }
            }
        }

        /* NOTE: would be nice to be able to rely on null-terminated string */
        ++path_buf_len;
        Newxz(path_buf, path_buf_len, char);

        errno = 0;
        ret = zoo_create(zk->handle, path, buf, buf_len,
                         (acl_arr ? &acl : NULL), flags,
                         path_buf, path_buf_len);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (acl_arr) {
            _zk_free_acl(aTHX_ &acl);
        }

        if (ret == ZOK) {
            ST(0) = sv_newmortal();
#ifdef SV_HAS_TRAILING_NUL
            sv_usepvn_flags(ST(0), path_buf, strlen(path_buf),
                            SV_HAS_TRAILING_NUL);
#else
            sv_usepvn(ST(0), path_buf, strlen(path_buf));
#endif
            SvCUR_set(ST(0), strlen(path_buf));

            XSRETURN(1);
        }

        Safefree(path_buf);

        XSRETURN_UNDEF;
#line 1883 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_delete)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "zkh, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1390 "ZooKeeper.xs"
        zk_t *zk;
        int version = -1;
        int i, ret;
#line 1906 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1394 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 2 && items % 2) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        for (i = 2; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "version")) {
                version = SvIV(ST(i + 1));

                if (version < 0) {
                    Perl_croak(aTHX_ "invalid version requirement: %d",
                               version);
                }
            }
        }

        errno = 0;
        ret = zoo_delete(zk->handle, path, version);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 1956 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_exists)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "zkh, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1439 "ZooKeeper.xs"
        zk_t *zk;
        zk_stat_t *stat = NULL;
        zk_watch_t *old_watch = NULL;
        zk_handle_t *watch_handle = NULL;
        watcher_fn watcher = NULL;
        zk_watch_t *new_watch = NULL;
        int i, ret;
#line 1983 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1447 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 2 && items % 2) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        for (i = 2; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "stat")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), STAT_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "stat is not a hash reference of "
                                     "type " STAT_PACKAGE_NAME);
                }

                stat = _zks_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)));

                if (!stat) {
                    Perl_croak(aTHX_ "invalid stat handle");
                }
            }
            else if (strcaseEQ(key, "watch")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), WATCH_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "watch is not a hash reference of "
                                     "type " WATCH_PACKAGE_NAME);
                }

                old_watch = _zkw_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)),
                                                  &watch_handle);

                if (!old_watch) {
                    Perl_croak(aTHX_ "invalid watch handle");
                }
            }
        }

        if (watch_handle) {
            new_watch = _zk_acquire_watch(aTHX);

            if (!new_watch) {
                /* errno will be set */
                zk->last_ret = ZSYSTEMERROR;
                zk->last_errno = errno;

                XSRETURN_NO;
            }

            watcher = _zk_watcher;
        }

        errno = 0;
        ret = zoo_wexists(zk->handle, path, watcher, new_watch, stat);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (watch_handle) {
            _zk_replace_watch(aTHX_ watch_handle, zk->first_watch,
                              old_watch, new_watch);
        }

        if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 2071 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_get_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_get_children)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "zkh, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1530 "ZooKeeper.xs"
        zk_t *zk;
        zk_watch_t *old_watch = NULL;
        zk_handle_t *watch_handle = NULL;
        watcher_fn watcher = NULL;
        zk_watch_t *new_watch = NULL;
        struct String_vector strings;
        int i, ret;
#line 2098 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1538 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 2 && items % 2) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        for (i = 2; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "watch")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), WATCH_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "watch is not a hash reference of "
                                     "type " WATCH_PACKAGE_NAME);
                }

                old_watch = _zkw_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)),
                                                  &watch_handle);

                if (!old_watch) {
                    Perl_croak(aTHX_ "invalid watch handle");
                }
            }
        }

        if (watch_handle) {
            new_watch = _zk_acquire_watch(aTHX);

            if (!new_watch) {
                /* errno will be set */
                zk->last_ret = ZSYSTEMERROR;
                zk->last_errno = errno;

                if (GIMME_V == G_ARRAY) {
                    XSRETURN_EMPTY;
                }
                else {
                    XSRETURN_UNDEF;
                }
            }

            watcher = _zk_watcher;
        }

        Zero(&strings, 1, struct String_vector);

        errno = 0;
        ret = zoo_wget_children(zk->handle, path, watcher, new_watch,
                                &strings);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (watch_handle) {
            _zk_replace_watch(aTHX_ watch_handle, zk->first_watch,
                              old_watch, new_watch);
        }

        if (ret == ZOK) {
            int num_children;

            num_children =
                (strings.count > PERL_INT_MAX) ? PERL_INT_MAX : strings.count;

            if (GIMME_V == G_ARRAY && num_children > 0) {
                EXTEND(SP, num_children);

                for (i = 0; i < num_children; ++i) {
                    ST(i) = sv_2mortal(newSVpv(strings.data[i], 0));
                }
            }

            /* NOTE: would be nice if this were documented as required */
            deallocate_String_vector(&strings);

            if (GIMME_V == G_ARRAY) {
                if (num_children == 0) {
                    XSRETURN_EMPTY;
                }

                XSRETURN(num_children);
            }
            else {
                ST(0) = sv_2mortal(newSViv(num_children));

                XSRETURN(1);
            }
        }
        else {
            if (GIMME_V == G_ARRAY) {
                XSRETURN_EMPTY;
            }
            else {
                XSRETURN_UNDEF;
            }
        }
#line 2213 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_get)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "zkh, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1648 "ZooKeeper.xs"
        zk_t *zk;
        int buf_len;
        zk_stat_t *stat = NULL;
        zk_watch_t *old_watch = NULL;
        zk_handle_t *watch_handle = NULL;
        char *buf;
        watcher_fn watcher = NULL;
        zk_watch_t *new_watch = NULL;
        int i, ret;
#line 2242 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1658 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 2 && items % 2) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        buf_len = zk->data_buf_len;

        for (i = 2; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "data_read_len")) {
                buf_len = SvIV(ST(i + 1));

                if (buf_len < 0) {
                    Perl_croak(aTHX_ "invalid data read length: %d",
                               buf_len);
                }
            }
            else if (strcaseEQ(key, "stat")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), STAT_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "stat is not a hash reference of "
                                     "type " STAT_PACKAGE_NAME);
                }

                stat = _zks_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)));

                if (!stat) {
                    Perl_croak(aTHX_ "invalid stat handle");
                }
            }
            else if (strcaseEQ(key, "watch")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), WATCH_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "watch is not a hash reference of "
                                     "type " WATCH_PACKAGE_NAME);
                }

                old_watch = _zkw_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)),
                                                  &watch_handle);

                if (!old_watch) {
                    Perl_croak(aTHX_ "invalid watch handle");
                }
            }
        }

        if (watch_handle) {
            new_watch = _zk_acquire_watch(aTHX);

            if (!new_watch) {
                /* errno will be set */
                zk->last_ret = ZSYSTEMERROR;
                zk->last_errno = errno;

                XSRETURN_UNDEF;
            }

            watcher = _zk_watcher;
        }

        Newx(buf, buf_len + 1, char);

        errno = 0;
        ret = zoo_wget(zk->handle, path, watcher, new_watch,
                       buf, &buf_len, stat);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (watch_handle) {
            _zk_replace_watch(aTHX_ watch_handle, zk->first_watch,
                              old_watch, new_watch);
        }

        if (ret == ZOK) {
            ST(0) = sv_newmortal();
#ifdef SV_HAS_TRAILING_NUL
            buf[buf_len] = '\0';
            sv_usepvn_flags(ST(0), buf, buf_len, SV_HAS_TRAILING_NUL);
#else
            sv_usepvn(ST(0), buf, buf_len);
#endif

            XSRETURN(1);
        }
        else {
            Safefree(buf);

            XSRETURN_UNDEF;
        }
#line 2353 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_set)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "zkh, path, buf, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	buf;
#line 1765 "ZooKeeper.xs"
        zk_t *zk;
        int version = -1;
        zk_stat_t *stat = NULL;
        STRLEN buf_len;
        int i, ret;
#line 2379 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;

	 buf = (char *) SvPV(ST(2), buf_len);
#line 1771 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 3 && !(items % 2)) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        if (buf_len > PERL_INT_MAX) {
            Perl_croak(aTHX_ "invalid data length: %u", buf_len);
        }

        for (i = 3; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "version")) {
                version = SvIV(ST(i + 1));

                if (version < 0) {
                    Perl_croak(aTHX_ "invalid version requirement: %d",
                               version);
                }
            }
            else if (strcaseEQ(key, "stat")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), STAT_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "stat is not a hash reference of "
                                     "type " STAT_PACKAGE_NAME);
                }

                stat = _zks_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)));

                if (!stat) {
                    Perl_croak(aTHX_ "invalid stat handle");
                }
            }
        }

        errno = 0;
        ret = zoo_set2(zk->handle, path, buf, buf_len, version, stat);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 2448 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_get_acl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_get_acl)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "zkh, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1833 "ZooKeeper.xs"
        zk_t *zk;
        zk_stat_t *stat = NULL;
        struct ACL_vector acl;
        int i, ret;
#line 2472 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1838 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 2 && items % 2) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        for (i = 2; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "stat")) {
                if (!SvROK(ST(i + 1)) || SvTYPE(SvRV(ST(i + 1))) != SVt_PVHV ||
                    !sv_derived_from(ST(i + 1), STAT_PACKAGE_NAME)) {
                    Perl_croak(aTHX_ "stat is not a hash reference of "
                                     "type " STAT_PACKAGE_NAME);
                }

                stat = _zks_get_handle_outer(aTHX_ (HV*) SvRV(ST(i + 1)));

                if (!stat) {
                    Perl_croak(aTHX_ "invalid stat handle");
                }
            }
        }

        errno = 0;
        ret = zoo_get_acl(zk->handle, path, &acl, stat);

        zk->last_ret = ret;
        zk->last_errno = errno;

        if (ret == ZOK) {
            int num_acl_entries;

            num_acl_entries =
                (acl.count > PERL_INT_MAX) ? PERL_INT_MAX : acl.count;

            if (GIMME_V == G_ARRAY && num_acl_entries > 0) {
                EXTEND(SP, num_acl_entries);

                for (i = 0; i < num_acl_entries; ++i) {
                    HV *acl_entry_hash = newHV();

                    _zk_fill_acl_entry_hash(aTHX_ &acl.data[i],
                                            acl_entry_hash);

                    ST(i) = sv_2mortal(newRV_noinc((SV*) acl_entry_hash));
                }
            }

            /* NOTE: would be nice if this were documented as required */
            deallocate_ACL_vector(&acl);

            if (GIMME_V == G_ARRAY) {
                if (num_acl_entries == 0) {
                    XSRETURN_EMPTY;
                }

                XSRETURN(num_acl_entries);
            }
            else {
                ST(0) = sv_2mortal(newSViv(num_acl_entries));

                XSRETURN(1);
            }
        }
        else {
            if (GIMME_V == G_ARRAY) {
                XSRETURN_EMPTY;
            }
            else {
                XSRETURN_UNDEF;
            }
        }
#line 2564 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_set_acl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_set_acl)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "zkh, path, acl_arr, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	AV *	acl_arr;
#line 1926 "ZooKeeper.xs"
        zk_t *zk;
        const char *err;
        int version = -1;
        struct ACL_vector acl;
        int i, ret;
#line 2590 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    acl_arr = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::ZooKeeper::set_acl",
				"acl_arr");
		}
	} STMT_END
;
#line 1932 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 3 && !(items % 2)) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        err = _zk_fill_acl(aTHX_ acl_arr, &acl);

        if (err) {
            Perl_croak(aTHX_ err);
        }

        for (i = 3; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "version")) {
                version = SvIV(ST(i + 1));

                if (version < 0) {
                    Perl_croak(aTHX_ "invalid version requirement: %d",
                               version);
                }
            }
        }

        errno = 0;
        ret = zoo_set_acl(zk->handle, path, version, &acl);

        zk->last_ret = ret;
        zk->last_errno = errno;

        _zk_free_acl(aTHX_ &acl);

        if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 2662 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "zkh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
#line 1984 "ZooKeeper.xs"
        zk_t *zk;
        zk_handle_t *handle;
        HV *stash, *stat_hash, *attr_hash;
        SV *attr;
#line 2684 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 1989 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        Newx(handle, 1, zk_handle_t);

        handle->signature = STAT_PACKAGE_SIGNATURE;

        Newxz(handle->handle.stat, 1, zk_stat_t);

        /* As in zk_new(), we use two levels of magic here. */

        stash = gv_stashpv(STAT_PACKAGE_NAME, GV_ADDWARN);

        attr_hash = newHV();

        sv_magic((SV*) attr_hash, Nullsv, PERL_MAGIC_ext,
                 (const char*) handle, 0);

        attr = sv_bless(newRV_noinc((SV*) attr_hash), stash);

        stat_hash = newHV();

        sv_magic((SV*) stat_hash, attr, PERL_MAGIC_tied, Nullch, 0);
        SvREFCNT_dec(attr);

        ST(0) = sv_bless(sv_2mortal(newRV_noinc((SV*) stat_hash)), stash);

        XSRETURN(1);
#line 2730 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper_watch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper_watch)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "zkh, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper	zkh;
#line 2029 "ZooKeeper.xs"
        zk_t *zk;
        unsigned int timeout;
        zk_watch_t *watch;
        zk_handle_t *handle;
        HV *stash, *watch_hash, *attr_hash;
        SV *attr;
        int i;
#line 2755 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper")) {
	    zkh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkh is not a hash reference of type Net::ZooKeeper");
	}
;
#line 2037 "ZooKeeper.xs"
        zk = _zk_get_handle_outer(aTHX_ zkh);

        if (!zk) {
            Perl_croak(aTHX_ "invalid handle");
        }

        zk->last_ret = ZOK;
        zk->last_errno = 0;

        if (items > 1 && !(items % 2)) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        timeout = zk->watch_timeout;

        for (i = 1; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "timeout")) {
                timeout = SvUV(ST(i + 1));
            }
        }

        watch = _zk_acquire_watch(aTHX);

        if (!watch) {
            /* errno will be set */
            zk->last_ret = ZSYSTEMERROR;
            zk->last_errno = errno;

            XSRETURN_UNDEF;
        }

        Newx(handle, 1, zk_handle_t);

        handle->signature = WATCH_PACKAGE_SIGNATURE;
        handle->handle.watch = watch;

        /* As in zk_new(), we use two levels of magic here. */

        stash = gv_stashpv(WATCH_PACKAGE_NAME, GV_ADDWARN);

        attr_hash = newHV();

        watch->timeout = timeout;

        sv_magic((SV*) attr_hash, Nullsv, PERL_MAGIC_ext,
                 (const char*) handle, 0);

        attr = sv_bless(newRV_noinc((SV*) attr_hash), stash);

        watch_hash = newHV();

        sv_magic((SV*) watch_hash, attr, PERL_MAGIC_tied, Nullch, 0);
        SvREFCNT_dec(attr);

        ST(0) = sv_bless(sv_2mortal(newRV_noinc((SV*) watch_hash)), stash);

        XSRETURN(1);
#line 2826 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "zksh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	zksh;
#line 2104 "ZooKeeper.xs"
        zk_handle_t *handle;
        HV *attr_hash;
        int ret = ZBADARGUMENTS;
#line 2847 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    zksh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zksh is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2108 "ZooKeeper.xs"
        handle = _zk_check_handle_outer(aTHX_ zksh, &attr_hash,
                                        STAT_PACKAGE_NAME,
                                        STAT_PACKAGE_SIGNATURE);

        if (!handle) {
            handle = _zk_check_handle_inner(aTHX_ zksh,
                                            STAT_PACKAGE_SIGNATURE);

            if (handle) {
                attr_hash = zksh;
                zksh = NULL;
            }
        }

        if (handle) {
            ret = ZOK;

            Safefree(handle->handle.stat);
            Safefree(handle);

            sv_unmagic((SV*) attr_hash, PERL_MAGIC_ext);
        }

        if (zksh && attr_hash) {
            sv_unmagic((SV*) zksh, PERL_MAGIC_tied);
        }

        if (GIMME_V == G_VOID) {
            XSRETURN_EMPTY;
        }
        else if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 2895 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_CLONE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 2150 "ZooKeeper.xs"
        XSRETURN_EMPTY;
#line 2915 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_CLONE_SKIP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 2157 "ZooKeeper.xs"
        XSRETURN_YES;
#line 2935 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_TIEHASH)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "package, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 2164 "ZooKeeper.xs"
        Perl_croak(aTHX_ "tying hashes of class "
                         STAT_PACKAGE_NAME " not supported");
#line 2956 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_UNTIE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_UNTIE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, ref_count");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
	IV	ref_count = (IV)SvIV(ST(1))
;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2173 "ZooKeeper.xs"
        Perl_croak(aTHX_ "untying hashes of class "
                         STAT_PACKAGE_NAME " not supported");
#line 2988 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
#line 2181 "ZooKeeper.xs"
        zk_stat_t *stat;
#line 3007 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2183 "ZooKeeper.xs"
        stat = _zks_get_handle_inner(aTHX_ attr_hash);

        if (!stat) {
            Perl_croak(aTHX_ "invalid handle");
        }

        ST(0) = sv_2mortal(newSVpvn(zk_stat_keys[0].name,
                                    zk_stat_keys[0].name_len));

        XSRETURN(1);
#line 3029 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
	SV *	attr_key = ST(1)
;
#line 2200 "ZooKeeper.xs"
        zk_stat_t *stat;
        char *key;
        int i;
#line 3052 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2204 "ZooKeeper.xs"
        stat = _zks_get_handle_inner(aTHX_ attr_hash);

        if (!stat) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_STAT_KEYS; ++i) {
            if (strcaseEQ(key, zk_stat_keys[i].name)) {
                ++i;

                break;
            }
        }

        if (i < NUM_STAT_KEYS) {
            ST(0) = sv_2mortal(newSVpvn(zk_stat_keys[i].name,
                                        zk_stat_keys[i].name_len));

            XSRETURN(1);
        }
        else {
            XSRETURN_EMPTY;
        }
#line 3089 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_SCALAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_SCALAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2235 "ZooKeeper.xs"
        XSRETURN_YES;
#line 3118 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
	SV *	attr_key = ST(1)
;
#line 2243 "ZooKeeper.xs"
        zk_stat_t *stat;
        char *key;
        SV *val = NULL;
        int i;
#line 3142 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2248 "ZooKeeper.xs"
        stat = _zks_get_handle_inner(aTHX_ attr_hash);

        if (!stat) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_STAT_KEYS; ++i) {
            if (strcaseEQ(key, zk_stat_keys[i].name)) {
                if (zk_stat_keys[i].size * CHAR_BIT == 32) {
                    val = newSViv(*((int32_t*) (((char*) stat) +
                                                zk_stat_keys[i].offset)));
                }
                else {
                    /* NOTE: %lld is inconsistent, so cast to a double */
                    val = newSVpvf("%.0f", (double)
                                   *((int64_t*) (((char*) stat) +
                                                 zk_stat_keys[i].offset)));
                }

                break;
            }
        }

        if (val) {
            ST(0) = sv_2mortal(val);

            XSRETURN(1);
        }

        Perl_warn(aTHX_ "invalid element: %s", key);

        XSRETURN_UNDEF;
#line 3188 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "attr_hash, attr_key, attr_val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
	SV *	attr_key = ST(1)
;
	SV *	attr_val = ST(2)
;
#line 2290 "ZooKeeper.xs"
        zk_stat_t *stat;
        char *key;
        int i;
#line 3213 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2294 "ZooKeeper.xs"
        stat = _zks_get_handle_inner(aTHX_ attr_hash);

        if (!stat) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_STAT_KEYS; ++i) {
            if (strcaseEQ(key, zk_stat_keys[i].name)) {
                Perl_warn(aTHX_ "read-only element: %s", key);

                XSRETURN_EMPTY;
            }
        }

        Perl_warn(aTHX_ "invalid element: %s", key);

        XSRETURN_EMPTY;
#line 3244 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
	SV *	attr_key = ST(1)
;
#line 2320 "ZooKeeper.xs"
        zk_stat_t *stat;
        char *key;
        int i;
#line 3267 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2324 "ZooKeeper.xs"
        stat = _zks_get_handle_inner(aTHX_ attr_hash);

        if (!stat) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_STAT_KEYS; ++i) {
            if (strcaseEQ(key, zk_stat_keys[i].name)) {
                XSRETURN_YES;
            }
        }

        XSRETURN_NO;
#line 3294 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_DELETE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;
	SV *	attr_key = ST(1)
;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2346 "ZooKeeper.xs"
        Perl_warn(aTHX_ "deleting elements from hashes of class "
                        STAT_PACKAGE_NAME " not supported");

        XSRETURN_EMPTY;
#line 3328 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Stat_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Stat_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Stat	attr_hash;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Stat")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Stat");
	}
;
#line 2356 "ZooKeeper.xs"
        Perl_warn(aTHX_ "clearing hashes of class "
                        STAT_PACKAGE_NAME " not supported");

        XSRETURN_EMPTY;
#line 3360 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "zkwh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	zkwh;
#line 2368 "ZooKeeper.xs"
        zk_handle_t *handle;
        HV *attr_hash;
        int ret = ZBADARGUMENTS;
#line 3381 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    zkwh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkwh is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2372 "ZooKeeper.xs"
        handle = _zk_check_handle_outer(aTHX_ zkwh, &attr_hash,
                                        WATCH_PACKAGE_NAME,
                                        WATCH_PACKAGE_SIGNATURE);

        if (!handle) {
            handle = _zk_check_handle_inner(aTHX_ zkwh,
                                            WATCH_PACKAGE_SIGNATURE);

            if (handle) {
                attr_hash = zkwh;
                zkwh = NULL;
            }
        }

        if (handle) {
            ret = ZOK;

            _zk_release_watch(aTHX_ handle->handle.watch, 0);
            Safefree(handle);

            sv_unmagic((SV*) attr_hash, PERL_MAGIC_ext);
        }

        if (zkwh && attr_hash) {
            sv_unmagic((SV*) zkwh, PERL_MAGIC_tied);
        }

        if (GIMME_V == G_VOID) {
            XSRETURN_EMPTY;
        }
        else if (ret == ZOK) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 3429 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_CLONE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 2414 "ZooKeeper.xs"
        XSRETURN_EMPTY;
#line 3449 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_CLONE_SKIP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 2421 "ZooKeeper.xs"
        XSRETURN_YES;
#line 3469 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_TIEHASH)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "package, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 2428 "ZooKeeper.xs"
        Perl_croak(aTHX_ "tying hashes of class "
                         WATCH_PACKAGE_NAME " not supported");
#line 3490 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_UNTIE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_UNTIE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, ref_count");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
	IV	ref_count = (IV)SvIV(ST(1))
;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2437 "ZooKeeper.xs"
        Perl_croak(aTHX_ "untying hashes of class "
                         WATCH_PACKAGE_NAME " not supported");
#line 3522 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
#line 2445 "ZooKeeper.xs"
        zk_watch_t *watch;
#line 3541 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2447 "ZooKeeper.xs"
        watch = _zkw_get_handle_inner(aTHX_ attr_hash);

        if (!watch) {
            Perl_croak(aTHX_ "invalid handle");
        }

        ST(0) = sv_2mortal(newSVpvn(zk_watch_keys[0].name,
                                    zk_watch_keys[0].name_len));

        XSRETURN(1);
#line 3563 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
	SV *	attr_key = ST(1)
;
#line 2464 "ZooKeeper.xs"
        zk_watch_t *watch;
        char *key;
        int i;
#line 3586 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2468 "ZooKeeper.xs"
        watch = _zkw_get_handle_inner(aTHX_ attr_hash);

        if (!watch) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_WATCH_KEYS; ++i) {
            if (strcaseEQ(key, zk_watch_keys[i].name)) {
                ++i;

                break;
            }
        }

        if (i < NUM_WATCH_KEYS) {
            ST(0) = sv_2mortal(newSVpvn(zk_watch_keys[i].name,
                                        zk_watch_keys[i].name_len));

            XSRETURN(1);
        }
        else {
            XSRETURN_EMPTY;
        }
#line 3623 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_SCALAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_SCALAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2499 "ZooKeeper.xs"
        XSRETURN_YES;
#line 3652 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
	SV *	attr_key = ST(1)
;
#line 2507 "ZooKeeper.xs"
        zk_watch_t *watch;
        char *key;
        SV *val = NULL;
#line 3675 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2511 "ZooKeeper.xs"
        watch = _zkw_get_handle_inner(aTHX_ attr_hash);

        if (!watch) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        if (strcaseEQ(key, "timeout")) {
            val = newSVuv(watch->timeout);
        }
        else if (strcaseEQ(key, "event")) {
            val = newSViv(watch->event_type);
        }
        else if (strcaseEQ(key, "state")) {
            val = newSViv(watch->event_state);
        }

        if (val) {
            ST(0) = sv_2mortal(val);

            XSRETURN(1);
        }

        Perl_warn(aTHX_ "invalid element: %s", key);

        XSRETURN_UNDEF;
#line 3714 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "attr_hash, attr_key, attr_val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
	SV *	attr_key = ST(1)
;
	SV *	attr_val = ST(2)
;
#line 2546 "ZooKeeper.xs"
        zk_watch_t *watch;
        char *key;
#line 3738 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2549 "ZooKeeper.xs"
        watch = _zkw_get_handle_inner(aTHX_ attr_hash);

        if (!watch) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        if (strcaseEQ(key, "timeout")) {
            watch->timeout = SvUV(attr_val);
        }
        else {
            int i;

            for (i = 0; i < NUM_WATCH_KEYS; ++i) {
                if (strcaseEQ(key, zk_watch_keys[i].name)) {
                    Perl_warn(aTHX_ "read-only element: %s", key);

                    XSRETURN_EMPTY;
                }
            }

            Perl_warn(aTHX_ "invalid element: %s", key);
        }

        XSRETURN_EMPTY;
#line 3776 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
	SV *	attr_key = ST(1)
;
#line 2582 "ZooKeeper.xs"
        zk_watch_t *watch;
        char *key;
        int i;
#line 3799 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2586 "ZooKeeper.xs"
        watch = _zkw_get_handle_inner(aTHX_ attr_hash);

        if (!watch) {
            Perl_croak(aTHX_ "invalid handle");
        }

        key = SvPV_nolen(attr_key);

        for (i = 0; i < NUM_WATCH_KEYS; ++i) {
            if (strcaseEQ(key, zk_watch_keys[i].name)) {
                XSRETURN_YES;
            }
        }

        XSRETURN_NO;
#line 3826 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_DELETE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "attr_hash, attr_key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;
	SV *	attr_key = ST(1)
;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2608 "ZooKeeper.xs"
        Perl_warn(aTHX_ "deleting elements from hashes of class "
                        WATCH_PACKAGE_NAME " not supported");

        XSRETURN_EMPTY;
#line 3860 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "attr_hash");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	attr_hash;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    attr_hash = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "attr_hash is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2618 "ZooKeeper.xs"
        Perl_warn(aTHX_ "clearing hashes of class "
                        WATCH_PACKAGE_NAME " not supported");

        XSRETURN_EMPTY;
#line 3892 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__ZooKeeper__Watch_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__ZooKeeper__Watch_wait)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "zkwh, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__ZooKeeper__Watch	zkwh;
#line 2628 "ZooKeeper.xs"
        zk_watch_t *watch;
        unsigned int timeout;
        struct timeval end_timeval;
        int i, done;
        struct timespec wait_timespec;
#line 3915 "ZooKeeper.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVHV &&
	    sv_derived_from(ST(0), "Net::ZooKeeper::Watch")) {
	    zkwh = (HV*) SvRV(ST(0));
	}
	else {
	    Perl_croak(aTHX_
                       "zkwh is not a hash reference of type Net::ZooKeeper::Watch");
	}
;
#line 2634 "ZooKeeper.xs"
        watch = _zkw_get_handle_outer(aTHX_ zkwh, NULL);

        if (!watch) {
            Perl_croak(aTHX_ "invalid handle");
        }

        if (items > 1 && !(items % 2)) {
            Perl_croak(aTHX_ "invalid number of arguments");
        }

        timeout = watch->timeout;

        for (i = 1; i < items; i += 2) {
            char *key = SvPV_nolen(ST(i));

            if (strcaseEQ(key, "timeout")) {
                timeout = SvUV(ST(i + 1));
            }
        }

        gettimeofday(&end_timeval, NULL);

        end_timeval.tv_sec += timeout / 1000;
        end_timeval.tv_usec += (timeout % 1000) * 1000;
        if (end_timeval.tv_usec >= 1000000) {
            end_timeval.tv_usec -= 1000000;
            end_timeval.tv_sec++;
        }

        wait_timespec.tv_sec = end_timeval.tv_sec;
        wait_timespec.tv_nsec = end_timeval.tv_usec * 1000;

        pthread_mutex_lock(&watch->mutex);

        while (!watch->done) {
            struct timeval curr_timeval;

            gettimeofday(&curr_timeval, NULL);

            if (end_timeval.tv_sec < curr_timeval.tv_sec ||
                (end_timeval.tv_sec == curr_timeval.tv_sec &&
                 end_timeval.tv_usec <= curr_timeval.tv_usec)) {
                break;
            }

            pthread_cond_timedwait(&watch->cond, &watch->mutex,
                                   &wait_timespec);
        }

        done = watch->done;

        pthread_mutex_unlock(&watch->mutex);

        if (done) {
            XSRETURN_YES;
        }
        else {
            XSRETURN_NO;
        }
#line 3986 "ZooKeeper.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__ZooKeeper); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__ZooKeeper)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        cv = newXSproto_portable("Net::ZooKeeper::ZAPIERROR", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZAPIERROR;
        cv = newXSproto_portable("Net::ZooKeeper::ZAUTHFAILED", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZAUTHFAILED;
        cv = newXSproto_portable("Net::ZooKeeper::ZBADARGUMENTS", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZBADARGUMENTS;
        cv = newXSproto_portable("Net::ZooKeeper::ZBADVERSION", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZBADVERSION;
        cv = newXSproto_portable("Net::ZooKeeper::ZCLOSING", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZCLOSING;
        cv = newXSproto_portable("Net::ZooKeeper::ZCONNECTIONLOSS", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZCONNECTIONLOSS;
        cv = newXSproto_portable("Net::ZooKeeper::ZDATAINCONSISTENCY", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZDATAINCONSISTENCY;
        cv = newXSproto_portable("Net::ZooKeeper::ZINVALIDACL", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZINVALIDACL;
        cv = newXSproto_portable("Net::ZooKeeper::ZINVALIDCALLBACK", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZINVALIDCALLBACK;
        cv = newXSproto_portable("Net::ZooKeeper::ZINVALIDSTATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZINVALIDSTATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZMARSHALLINGERROR", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZMARSHALLINGERROR;
        cv = newXSproto_portable("Net::ZooKeeper::ZNOAUTH", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZNOAUTH;
        cv = newXSproto_portable("Net::ZooKeeper::ZNOCHILDRENFOREPHEMERALS", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZNOCHILDRENFOREPHEMERALS;
        cv = newXSproto_portable("Net::ZooKeeper::ZNODEEXISTS", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZNODEEXISTS;
        cv = newXSproto_portable("Net::ZooKeeper::ZNONODE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZNONODE;
        cv = newXSproto_portable("Net::ZooKeeper::ZNOTEMPTY", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZNOTEMPTY;
        cv = newXSproto_portable("Net::ZooKeeper::ZNOTHING", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZNOTHING;
        cv = newXSproto_portable("Net::ZooKeeper::ZOK", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOK;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_ASSOCIATING_STATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_ASSOCIATING_STATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_AUTH_FAILED_STATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_AUTH_FAILED_STATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_CHANGED_EVENT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_CHANGED_EVENT;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_CHILD_EVENT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_CHILD_EVENT;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_CONNECTED_STATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_CONNECTED_STATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_CONNECTING_STATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_CONNECTING_STATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_CREATED_EVENT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_CREATED_EVENT;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_DELETED_EVENT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_DELETED_EVENT;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_EPHEMERAL", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_EPHEMERAL;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_EXPIRED_SESSION_STATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_EXPIRED_SESSION_STATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_LOG_LEVEL_DEBUG", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_LOG_LEVEL_DEBUG;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_LOG_LEVEL_ERROR", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_LOG_LEVEL_ERROR;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_LOG_LEVEL_INFO", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_LOG_LEVEL_INFO;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_LOG_LEVEL_OFF", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_LOG_LEVEL_OFF;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_LOG_LEVEL_WARN", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_LOG_LEVEL_WARN;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_NOTWATCHING_EVENT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_NOTWATCHING_EVENT;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_PERM_ADMIN", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_PERM_ADMIN;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_PERM_ALL", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_PERM_ALL;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_PERM_CREATE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_PERM_CREATE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_PERM_DELETE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_PERM_DELETE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_PERM_READ", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_PERM_READ;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_PERM_WRITE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_PERM_WRITE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_SEQUENCE", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_SEQUENCE;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_SESSION_EVENT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOO_SESSION_EVENT;
        cv = newXSproto_portable("Net::ZooKeeper::ZOPERATIONTIMEOUT", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZOPERATIONTIMEOUT;
        cv = newXSproto_portable("Net::ZooKeeper::ZRUNTIMEINCONSISTENCY", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZRUNTIMEINCONSISTENCY;
        cv = newXSproto_portable("Net::ZooKeeper::ZSESSIONEXPIRED", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZSESSIONEXPIRED;
        cv = newXSproto_portable("Net::ZooKeeper::ZSESSIONMOVED", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZSESSIONMOVED;
        cv = newXSproto_portable("Net::ZooKeeper::ZSYSTEMERROR", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZSYSTEMERROR;
        cv = newXSproto_portable("Net::ZooKeeper::ZUNIMPLEMENTED", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = ZUNIMPLEMENTED;
        cv = newXSproto_portable("Net::ZooKeeper::constant", XS_Net__ZooKeeper_constant, file, ";$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_CREATOR_ALL_ACL", XS_Net__ZooKeeper_acl_constant, file, ";$");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_OPEN_ACL_UNSAFE", XS_Net__ZooKeeper_acl_constant, file, ";$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Net::ZooKeeper::ZOO_READ_ACL_UNSAFE", XS_Net__ZooKeeper_acl_constant, file, ";$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Net::ZooKeeper::acl_constant", XS_Net__ZooKeeper_acl_constant, file, ";$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Net::ZooKeeper::set_log_level", XS_Net__ZooKeeper_set_log_level, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::set_deterministic_conn_order", XS_Net__ZooKeeper_set_deterministic_conn_order, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::set_ignore_session_events", XS_Net__ZooKeeper_set_ignore_session_events, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::new", XS_Net__ZooKeeper_new, file, "$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::DESTROY", XS_Net__ZooKeeper_DESTROY, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::CLONE", XS_Net__ZooKeeper_CLONE, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::CLONE_SKIP", XS_Net__ZooKeeper_CLONE_SKIP, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::TIEHASH", XS_Net__ZooKeeper_TIEHASH, file, "$;@");
        (void)newXSproto_portable("Net::ZooKeeper::UNTIE", XS_Net__ZooKeeper_UNTIE, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::FIRSTKEY", XS_Net__ZooKeeper_FIRSTKEY, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::NEXTKEY", XS_Net__ZooKeeper_NEXTKEY, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::SCALAR", XS_Net__ZooKeeper_SCALAR, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::FETCH", XS_Net__ZooKeeper_FETCH, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::STORE", XS_Net__ZooKeeper_STORE, file, "$$$");
        (void)newXSproto_portable("Net::ZooKeeper::EXISTS", XS_Net__ZooKeeper_EXISTS, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::DELETE", XS_Net__ZooKeeper_DELETE, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::CLEAR", XS_Net__ZooKeeper_CLEAR, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::get_error", XS_Net__ZooKeeper_get_error, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::add_auth", XS_Net__ZooKeeper_add_auth, file, "$$$");
        (void)newXSproto_portable("Net::ZooKeeper::create", XS_Net__ZooKeeper_create, file, "$$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::delete", XS_Net__ZooKeeper_delete, file, "$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::exists", XS_Net__ZooKeeper_exists, file, "$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::get_children", XS_Net__ZooKeeper_get_children, file, "$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::get", XS_Net__ZooKeeper_get, file, "$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::set", XS_Net__ZooKeeper_set, file, "$$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::get_acl", XS_Net__ZooKeeper_get_acl, file, "$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::set_acl", XS_Net__ZooKeeper_set_acl, file, "$$$;@");
        (void)newXSproto_portable("Net::ZooKeeper::stat", XS_Net__ZooKeeper_stat, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::watch", XS_Net__ZooKeeper_watch, file, "$;@");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::DESTROY", XS_Net__ZooKeeper__Stat_DESTROY, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::CLONE", XS_Net__ZooKeeper__Stat_CLONE, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::CLONE_SKIP", XS_Net__ZooKeeper__Stat_CLONE_SKIP, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::TIEHASH", XS_Net__ZooKeeper__Stat_TIEHASH, file, "$;@");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::UNTIE", XS_Net__ZooKeeper__Stat_UNTIE, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::FIRSTKEY", XS_Net__ZooKeeper__Stat_FIRSTKEY, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::NEXTKEY", XS_Net__ZooKeeper__Stat_NEXTKEY, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::SCALAR", XS_Net__ZooKeeper__Stat_SCALAR, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::FETCH", XS_Net__ZooKeeper__Stat_FETCH, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::STORE", XS_Net__ZooKeeper__Stat_STORE, file, "$$$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::EXISTS", XS_Net__ZooKeeper__Stat_EXISTS, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::DELETE", XS_Net__ZooKeeper__Stat_DELETE, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Stat::CLEAR", XS_Net__ZooKeeper__Stat_CLEAR, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::DESTROY", XS_Net__ZooKeeper__Watch_DESTROY, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::CLONE", XS_Net__ZooKeeper__Watch_CLONE, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::CLONE_SKIP", XS_Net__ZooKeeper__Watch_CLONE_SKIP, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::TIEHASH", XS_Net__ZooKeeper__Watch_TIEHASH, file, "$;@");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::UNTIE", XS_Net__ZooKeeper__Watch_UNTIE, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::FIRSTKEY", XS_Net__ZooKeeper__Watch_FIRSTKEY, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::NEXTKEY", XS_Net__ZooKeeper__Watch_NEXTKEY, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::SCALAR", XS_Net__ZooKeeper__Watch_SCALAR, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::FETCH", XS_Net__ZooKeeper__Watch_FETCH, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::STORE", XS_Net__ZooKeeper__Watch_STORE, file, "$$$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::EXISTS", XS_Net__ZooKeeper__Watch_EXISTS, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::DELETE", XS_Net__ZooKeeper__Watch_DELETE, file, "$$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::CLEAR", XS_Net__ZooKeeper__Watch_CLEAR, file, "$");
        (void)newXSproto_portable("Net::ZooKeeper::Watch::wait", XS_Net__ZooKeeper__Watch_wait, file, "$;@");

    /* Initialisation Section */

#line 589 "ZooKeeper.xs"
{
    int i;

    for (i = 0; i < NUM_ACL_ENTRY_KEYS; ++i) {
        zk_key_t *key = &zk_acl_entry_keys[i];

        key->name_len = strlen(key->name);
        PERL_HASH(key->hash, key->name, key->name_len);
    }

    for (i = 0; i < NUM_KEYS; ++i) {
        zk_keys[i].name_len = strlen(zk_keys[i].name);
    }

    for (i = 0; i < NUM_STAT_KEYS; ++i) {
        zk_stat_keys[i].name_len = strlen(zk_stat_keys[i].name);
    }

    for (i = 0; i < NUM_WATCH_KEYS; ++i) {
        zk_watch_keys[i].name_len = strlen(zk_watch_keys[i].name);
    }

    zoo_set_log_stream(NULL);
    zoo_set_debug_level(0);
}

#line 4212 "ZooKeeper.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

